"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.login = exports.loginClient = exports.updatePassword = exports.setStoredLoginObj = exports.removeStoredLoginObj = exports.getStoredLoginObj = exports.logout = exports.unsubEntityUpdates = exports.subEntityUpdates = exports.unsub = exports.sub = exports.pubChannel = exports.pub = exports.confUpdatesChannel = exports.ridToBusChannel = exports.tapLogReqError = exports.logReqError = exports.req = exports.pwHash = exports.ds = void 0;

var _client = require("@deepstream/client");

var _sha = _interopRequireDefault(require("crypto-js/sha256"));

var R = _interopRequireWildcard(require("ramda"));

var _jstiip = _interopRequireDefault(require("jstiip"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var ds = {
  client: undefined
};
/**
 * Hash a password (or other string)
 * @param {string} pw A password
 * @returns {string} A hash string
 */

exports.ds = ds;

var pwHash = function pwHash(pw) {
  return String((0, _sha["default"])(pw));
};
/**
 * Performs a request to the backend.
 * TODO: Refactor temporarily to rids:* to target all, but only for 'conf...'-requests
 * @func
 * @static
 * @param {string} id The id of the rpc
 * @param {object} args Arguments passed on to the rpc
 * @return {Promise} A Promise
 */


exports.pwHash = pwHash;
var req = R.curry(function (id, args) {
  // console.debug('req:', id, args);
  return ds.client.rpc.make(id, args)["catch"](function (err) {
    console.error(id, args, err);
    throw err;
  });
});
exports.req = req;

var logReqError = function logReqError() {
  for (var _len = arguments.length, rpcs = new Array(_len), _key = 0; _key < _len; _key++) {
    rpcs[_key] = arguments[_key];
  }

  return function (err) {
    return console.warn("Request to \"".concat(rpcs.join('|'), "\" failed -"), err);
  };
};

exports.logReqError = logReqError;

var tapLogReqError = function tapLogReqError() {
  for (var _len2 = arguments.length, rpcs = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    rpcs[_key2] = arguments[_key2];
  }

  return function (err) {
    logReqError.apply(void 0, rpcs)(err);
    throw err;
  };
};
/**
 * From a rid, get the channel id on the bus
 * @param {string} rid Channel entity rid
 * @returns {string} A bus channel id for channel data
 */


exports.tapLogReqError = tapLogReqError;

var ridToBusChannel = function ridToBusChannel(rid) {
  return "data/".concat(rid);
};
/**
 * [curried] From type & rid, get the channel id for updates on that record
 * @param {string} type Type of entity
 * @param {string} rid Entity rid
 * @returns {string} A bus channel id for entity updates
 */


exports.ridToBusChannel = ridToBusChannel;
var confUpdatesChannel = R.curry(function (type, rid) {
  return "conf/".concat(type, "/update/").concat(rid);
});
/**
 * Publishes a message through the backend.
 * @func
 * @static
 * @param {string} channel The channel to publish on.
 * @param {Array} pl The payload to send.
 * @param {string} sig The signal data to apply to the published message.
 */

exports.confUpdatesChannel = confUpdatesChannel;

var pub = function pub(channel) {
  var pl = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var sig = arguments.length > 2 ? arguments[2] : undefined;
  var msg = new _jstiip["default"]({
    pl: pl
  });
  if (sig) msg.sig = sig;
  var msgOut = msg.toJS();
  ds.client.event.emit(channel, msgOut); // console.log('PUB:', channel, msgOut);
};
/**
 * Publishes a message on a channel, and returns a promise.
 * @func
 * @static
 * @param {string} channelRid The rid of the channel to publish on.
 * @param {Array} pl The payload to send.
 * @param {string} sig The signal data to apply to the published message.
 * @returns {Promise} Promisified success/error
 */


exports.pub = pub;

var pubChannel =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(channelRid) {
    var pl,
        sig,
        _args = arguments;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            pl = _args.length > 1 && _args[1] !== undefined ? _args[1] : [];
            sig = _args.length > 2 ? _args[2] : undefined;
            return _context.abrupt("return", pub(ridToBusChannel(channelRid), pl, sig));

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function pubChannel(_x) {
    return _ref.apply(this, arguments);
  };
}();
/**
 * Low-level subscribe to a channel on the backend. Recommended to use fromChannel instead.
 * @func
 * @static
 * @param {function} callback The callback to trigger when a message arrives.
 * @param {string} channel The channel to subscribe to.
 */


exports.pubChannel = pubChannel;
var sub = R.curry(function (callback, channel) {
  return ds.client.event.subscribe(channel, callback);
});
/**
 * Low-level unsubscribe from a channel on the backend (See fromChannel).
 * @func
 * @static
 * @param  {string} channel - The channel to unsubscribe from.
 * @param  {function} [callback] - The callback that was previously registered with subscribe. If
 *  the callback is omitted, all subscriptions for the channel will be removed.
 */

exports.sub = sub;

var unsub = function unsub(channel, callback) {
  return ds.client.event.unsubscribe(channel, callback);
};

exports.unsub = unsub;

var subEntityUpdates = function subEntityUpdates(type) {
  var ridToChannel = confUpdatesChannel(type);
  return function (cb) {
    return R.forEach(R.o(sub(cb), ridToChannel));
  };
};

exports.subEntityUpdates = subEntityUpdates;

var unsubEntityUpdates = function unsubEntityUpdates(type) {
  var ridToChannel = confUpdatesChannel(type);
  return function (rids, cb) {
    return R.forEach(R.o(function (ch) {
      return unsub(ch, cb);
    }, ridToChannel))(rids);
  };
};

exports.unsubEntityUpdates = unsubEntityUpdates;

var logout = function logout() {
  if (!ds.client) return;
  ds.client.off();
  ds.client.close();
};

exports.logout = logout;
var loginObjKey = '_loginObj_';

var getStoredLoginObj = function getStoredLoginObj() {
  try {
    return JSON.parse(localStorage.getItem(loginObjKey));
  } catch (err) {
    console.warn('Failed to get login object:', err);
    return undefined;
  }
};

exports.getStoredLoginObj = getStoredLoginObj;

var removeStoredLoginObj = function removeStoredLoginObj() {
  return localStorage.removeItem(loginObjKey);
};

exports.removeStoredLoginObj = removeStoredLoginObj;

var setStoredLoginObj = function setStoredLoginObj(obj) {
  try {
    localStorage.setItem(loginObjKey, JSON.stringify(obj));
    return true;
  } catch (err) {
    console.warn('Failed to save login:', err);
    return false;
  }
};

exports.setStoredLoginObj = setStoredLoginObj;

var updatePassword =
/*#__PURE__*/
function () {
  var _ref2 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2(oldUnhashed, newUnhashed) {
    var newHashed, loginObj;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            newHashed = pwHash(newUnhashed);
            _context2.next = 3;
            return req('conf/updateOwnPassword', {
              oldPassword: pwHash(oldUnhashed),
              newPassword: newHashed
            });

          case 3:
            loginObj = getStoredLoginObj();

            if (loginObj) {
              setStoredLoginObj(_objectSpread({}, loginObj, {
                password: newHashed
              }));
            }

          case 5:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function updatePassword(_x2, _x3) {
    return _ref2.apply(this, arguments);
  };
}();
/**
 * Creates a connection to the backend server.
 * @func
 * @static
 * @param {string} serverAddress
 * @param {function} options.onUnexpectedError Callback triggered on general errors in the client.
 * @return {object} - An extended deepstream client
 */


exports.updatePassword = updatePassword;

var createConnection = function createConnection(serverAddress, _ref3) {
  var onUnexpectedError = _ref3.onUnexpectedError,
      options = _objectWithoutProperties(_ref3, ["onUnexpectedError"]);

  console.log('createConnection:', serverAddress);
  var client = new _client.DeepstreamClient(serverAddress, options);
  if (onUnexpectedError) client.on('error', onUnexpectedError); // ARGS: (error, event, topic)

  return client;
};
/**
 * Helper function for logging in to an i4 server
 * @func
 * @static
 * @private
 * @param {object} client
 * @param {string} serverAddress
 * @param {string} id Client/user id
 * @param {string} password Probably hashed
 * @param {function} options.onConnectionError Callback invoked on a connection Error
 * @returns {object} An object with id, password and serverAddress
 */


var loginClient =
/*#__PURE__*/
function () {
  var _ref5 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee3(client, serverAddress, id, password, _ref4) {
    var onConnectionError, noLogging;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            onConnectionError = _ref4.onConnectionError, noLogging = _ref4.noLogging;
            _context3.next = 3;
            return client.login({
              id: id,
              password: password
            });

          case 3:
            // TODO: v5 "id" is "username"???
            client.on('connectionStateChanged', function (state) {
              if (!noLogging) console.log('CONNECTION STATE:', state);
              if (onConnectionError && state === 'ERROR') onConnectionError(); // All reconnects failed
            });
            return _context3.abrupt("return", {
              id: id,
              password: password,
              serverAddress: serverAddress
            });

          case 5:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function loginClient(_x4, _x5, _x6, _x7, _x8) {
    return _ref5.apply(this, arguments);
  };
}();
/**
 * Function for logging in to an i4 server. Will use a singleton "global" client.
 * @param {string} serverAddress Endpoint to connect to
 * @param {string} id Client/user id
 * @param {string} password The password (probably hashed)
 * @param {function} options.onConnectionError Callback invoked on a connection Error
 * @param {function} options.onUnexpectedError Callback triggered on general errors in the client
 * @returns {promise} Login promise
 */


exports.loginClient = loginClient;

var login = function login(serverAddress, id, password) {
  var _ref6 = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {},
      onConnectionError = _ref6.onConnectionError,
      onUnexpectedError = _ref6.onUnexpectedError,
      options = _objectWithoutProperties(_ref6, ["onConnectionError", "onUnexpectedError"]);

  if (ds.client) logout();
  ds.client = createConnection(serverAddress, _objectSpread({
    onUnexpectedError: onUnexpectedError
  }, options));
  return loginClient(ds.client, serverAddress, id, password, {
    onConnectionError: onConnectionError
  });
}; // const connectionMachine = Machine({
//   id: 'connection',
//   initial: 'offline',
//   states: {
//     offline: { on: { LOGIN: 'connecting' } },
//     connecting: {
//       invoke: {
//         src: 'login',
//         onDone: { target: 'authenticated' },
//         onError: { target: 'failed' },
//       },
//     },
//     error: { on: { RETRY: 'connecting' } },
//     connected: { on: { ERROR: 'error' } },
//     authenticated: {},
//   },
// });
//
// const connectionService = interpret(connectionMachine, {
//   actions: {
//     login: (ctx, ev) => login,
//   },
// }).start();


exports.login = login;