"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withRetryLoop = exports.pollUntil = exports.asyncWithTimeout = exports.triggerPromise = exports.wait = void 0;

var R = _interopRequireWildcard(require("ramda"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var wait = function wait(delay) {
  return new Promise(function (r) {
    return setTimeout(r, delay);
  });
};

exports.wait = wait;

var triggerPromise = function triggerPromise() {
  var resolve;
  var reject;
  var promise = new Promise(function (res, rej) {
    resolve = res;
    reject = rej;
  });
  return [promise, resolve, reject];
};

exports.triggerPromise = triggerPromise;

var asyncWithTimeout = function asyncWithTimeout(promise) {
  var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 3000;
  var timeoutResolve;
  var timeoutPromise = new Promise(function (resolve, reject) {
    timeoutResolve = resolve;
    setTimeout(function () {
      return reject(new Error('asyncWithTimeout: Timeout'));
    }, timeout);
  });
  Promise.race([promise["finally"](timeoutResolve), timeoutPromise]);
};

exports.asyncWithTimeout = asyncWithTimeout;
var pollUntil = R.curry(
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2(compareFn, fn) {
    var interval,
        _triggerPromise,
        _triggerPromise2,
        promise,
        resolve,
        inner,
        _args2 = arguments;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            interval = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : 10;
            _triggerPromise = triggerPromise(), _triggerPromise2 = _slicedToArray(_triggerPromise, 2), promise = _triggerPromise2[0], resolve = _triggerPromise2[1];

            inner =
            /*#__PURE__*/
            function () {
              var _ref2 = _asyncToGenerator(
              /*#__PURE__*/
              regeneratorRuntime.mark(function _callee() {
                var result;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return fn();

                      case 2:
                        result = _context.sent;
                        if (compareFn(result) === true) resolve(result);else setTimeout(inner, interval);

                      case 4:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function inner() {
                return _ref2.apply(this, arguments);
              };
            }();

            inner();
            return _context2.abrupt("return", promise);

          case 5:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}());
exports.pollUntil = pollUntil;

var withRetryLoop = function withRetryLoop(_ref3) {
  var onRetry = _ref3.onRetry,
      _ref3$delay = _ref3.delay,
      delay = _ref3$delay === void 0 ? 1 : _ref3$delay,
      _ref3$delta = _ref3.delta,
      delta = _ref3$delta === void 0 ? 2 : _ref3$delta,
      _ref3$maxDelay = _ref3.maxDelay,
      maxDelay = _ref3$maxDelay === void 0 ? 60 : _ref3$maxDelay;
  return function (fn) {
    return function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return fn.apply(void 0, args)["catch"](function (err) {
        if (onRetry) onRetry(err, delay);
        return wait(delay).then(function () {
          return withRetryLoop(fn, {
            onRetry: onRetry,
            delay: Math.min(delay + delta, maxDelay),
            delta: delta,
            maxDelay: maxDelay
          }).apply(void 0, args);
        });
      });
    };
  };
}; // --- NOT WORKING --- Timeout needs to be handled some other way (asyncWithTimeout?? Or setInterval?)
// export const pollUntilWithTimeout = R.curry(
//   async (compareFn, fn, interval = 10, timeout = 0, ignoreReject = false) => {
//     const [promise, resolve, reject] = triggerPromise();
//     const startTime = Date.now();
//     const inner = async () => {
//       let result;
//       let threw = false;
//       try {
//         result = await fn();
//       } catch (err) {
//         if (!ignoreReject) throw err;
//         // console.log('THREW', `(${err})`);
//         threw = true;
//       }
//       const compareResult = await compareFn(result);
//       // console.log('compareResult:', compareResult);
//       // console.log('threw:', threw);
//       const done = !threw && compareResult;
//       // console.log('done:', done);
//       if (done) resolve(result);
//       else if (Date.now() - startTime > timeout) {
//         clearTimeout(timer);
//         reject('pollUntil: Timeout');
//       } else setTimeout(inner(), interval);
//     };
//     inner();
//     return promise;
//   },
// );


exports.withRetryLoop = withRetryLoop;