"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connectAndLogin = exports.updatePassword = exports.setStoredLoginObj = exports.removeStoredLoginObj = exports.getStoredLoginObj = void 0;

var _extendedDsClient = require("extended-ds-client");

var _beClient = require("./be-client");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var loginObjKey = '_loginObj_';

var getStoredLoginObj = function getStoredLoginObj() {
  try {
    return JSON.parse(localStorage.getItem(loginObjKey));
  } catch (err) {
    console.warn('Failed to get login object:', err);
    return undefined;
  }
};

exports.getStoredLoginObj = getStoredLoginObj;

var removeStoredLoginObj = function removeStoredLoginObj() {
  return localStorage.removeItem(loginObjKey);
};

exports.removeStoredLoginObj = removeStoredLoginObj;

var setStoredLoginObj = function setStoredLoginObj(obj) {
  try {
    localStorage.setItem(loginObjKey, JSON.stringify(obj));
    return true;
  } catch (err) {
    console.warn('Failed to save login:', err);
    return false;
  }
};

exports.setStoredLoginObj = setStoredLoginObj;

var updatePassword =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(oldUnhashed, newUnhashed) {
    var newHashed, loginObj, id, serverAddress;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            newHashed = (0, _beClient.pwHash)(newUnhashed);
            _context.next = 3;
            return (0, _beClient.updateOwnPassword)({
              oldPassword: (0, _beClient.pwHash)(oldUnhashed),
              newPassword: newHashed
            });

          case 3:
            loginObj = getStoredLoginObj();

            if (loginObj) {
              id = loginObj.id, serverAddress = loginObj.serverAddress;
              setStoredLoginObj({
                id: id,
                password: newHashed,
                serverAddress: serverAddress
              });
            }

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function updatePassword(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}(); // TODO: Use XState for a login state machine


exports.updatePassword = updatePassword;

var connectAndLogin =
/*#__PURE__*/
function () {
  var _ref2 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2(id, password, serverAddress, onConnectionError, onUnexpectedError) {
    var loginObj, connectionObj;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (id) {// ...
            }

            loginObj = getStoredLoginObj();

            if (loginObj) {} // ...
            // const { id, password, serverAddress } = loginObj;


            _context2.next = 5;
            return (0, _beClient.login)(serverAddress, id, password, onConnectionError, onUnexpectedError);

          case 5:
            connectionObj = _context2.sent;

            if (!connectionObj) {// ...
            }

          case 7:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function connectAndLogin(_x3, _x4, _x5, _x6, _x7) {
    return _ref2.apply(this, arguments);
  };
}();

exports.connectAndLogin = connectAndLogin;