"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.stopDeepstreamServer = exports.getStartedDeepstreamServer = exports.provide = void 0;

var _server = require("@deepstream/server");

var _ctrlUtils = require("../ctrl-utils");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var provide =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(dsClient, name, callback) {
    var interval,
        finished,
        internalCallback,
        _args = arguments;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            interval = _args.length > 3 && _args[3] !== undefined ? _args[3] : 20;
            finished = false;

            internalCallback = function internalCallback(data, response) {
              if (finished) callback(data, response);else {
                response.send();
                finished = true;
              }
            };

            dsClient.rpc.provide(name, internalCallback);
            return _context.abrupt("return", (0, _ctrlUtils.pollUntil)(function () {
              return finished;
            }, function () {
              return dsClient.rpc.make(name);
            }, interval // 5000,
            // true,
            ));

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function provide(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

exports.provide = provide;

var getStartedDeepstreamServer = function getStartedDeepstreamServer() {
  var confName = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'empty';
  // const dss = new Deepstream();
  var dss = new _server.Deepstream("../node_modules/i4-js-commons/dist/testing/".concat(confName, "DsConf.yml"));

  var _triggerPromise = (0, _ctrlUtils.triggerPromise)(),
      _triggerPromise2 = _slicedToArray(_triggerPromise, 2),
      serverStartPromise = _triggerPromise2[0],
      serverStartResolve = _triggerPromise2[1];

  dss.on('started', serverStartResolve);
  dss.start();
  return [(0, _ctrlUtils.asyncWithTimeout)(serverStartPromise), dss];
};

exports.getStartedDeepstreamServer = getStartedDeepstreamServer;

var stopDeepstreamServer = function stopDeepstreamServer(server) {
  var _triggerPromise3 = (0, _ctrlUtils.triggerPromise)(),
      _triggerPromise4 = _slicedToArray(_triggerPromise3, 2),
      serverStopPromise = _triggerPromise4[0],
      serverStopResolve = _triggerPromise4[1];

  server.on('stopped', serverStopResolve);
  server.stop();
  return (0, _ctrlUtils.asyncWithTimeout)(serverStopPromise);
};

exports.stopDeepstreamServer = stopDeepstreamServer;